/*
 * Copyright (c) 2011-2013, Yahoo! Inc.  All rights reserved.
 * Copyrights licensed under the New BSD License.
 * See the accompanying LICENSE file for terms.
 */

YUI.add('flickrbrowser-binder-index', function (Y, NAME) {
    "use strict";
/**
 * The flickrbrowser-binder-index module.
 *
 * @module flickrbrowser-binder-index
 */

    /**
     * Constructor for the Binder class.
     *
     * @param mojitProxy {Object} The proxy to allow the binder to interact
     *        with its owning mojit.
     *
     * @class Binder
     * @constructor
     */

    Y.namespace('mojito.binders')[NAME] = {

        /**
         * Binder initialization method, invoked after all binders on the page
         * have been constructed.
         */
        init: function (mojitProxy) {
            this.mojitProxy = mojitProxy;
            this.mojitProxy.listen('flickr-image-chosen', function (event) {
                Y.log('on flickr-image-chosen ' + event.data.id, 'debug', NAME);
                // Turn the event generated by PagedFlickr into something
                // understood by FlickrDetail.
                mojitProxy.broadcast('flickr-image-detail', { id: event.data.id });
            });
        },

        /**
         * The binder method, invoked to allow the mojit to attach DOM event
         * handlers.
         *
         * @param node {Node} The DOM node to which this mojit is attached.
         */
        bind: function (node) {}

    };

}, '0.0.1', {requires: ['mojito-client']});
